<?php

	function uc_idealcheckoutcreditcard_return($sOrderId = '', $sOrderCode = '')
	{
		global $base_url;

		if(!preg_match('/^([a-zA-Z0-9]+)$/i', $sOrderId) || !preg_match('/^([a-zA-Z0-9]+)$/i', $sOrderCode))
		{
			drupal_goto($base_url . '/cart');
		}

		$aDatabaseSettings = idealcheckout_getDatabaseSettings();

		$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE `order_id` = '" . idealcheckout_escapeSql($sOrderId) . "' AND (`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "') ORDER BY `id` DESC LIMIT 1;";
		if($aRecord = idealcheckout_database_getRecord($sql))
		{
			$aOrderParams = idealcheckout_unserialize($aRecord['order_params']);
			$oOrder = uc_order_load($aRecord['order_id']);

			if($oOrder === FALSE)
			{
				drupal_goto($base_url . '/cart');
			}

			if(in_array($aRecord['transaction_status'], array('SUCCESS')))
			{
				$sql = "SELECT `order_status` FROM `uc_orders` WHERE (`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "') LIMIT 1";
				if($aOrder = idealcheckout_database_getRecord($sql))
				{
					if(in_array($aOrder['order_status'], array('payment_recieved', 'completed')))
					{
						// Status is final, don't update!
					}
					else
					{
						uc_order_comment_save($oOrder->order_id, 0, t('Recieved order status ' . $aRecord['transaction_status'] . ' from Payment Service Provider.'), 'admin');

						$sql = "UPDATE `uc_orders` SET `order_status` = 'payment_received' WHERE (`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "') LIMIT 1";
						idealcheckout_database_query($sql);


						// Clear cart
						if(!empty($aOrderParams['cart']['id']))
						{
							// Clear shopping cart
							// uc_cart_empty($aOrderParams['cart']['id']);
						}


						// Send payment notification mail
						// ..


						// Save order
						$output = uc_cart_complete_sale($oOrder, variable_get('uc_new_customer_login', FALSE));
					}

					$page = variable_get('uc_cart_checkout_complete_page', '');

					if(!empty($page))
					{
						drupal_goto($page);
					}

					return $output;
				}
			}
			elseif(in_array($aRecord['transaction_status'], array('PENDING', 'PROCESSING')))
			{
				$sql = "SELECT `order_status` FROM `uc_orders` WHERE (`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "') LIMIT 1";
				if($aOrder = idealcheckout_database_getRecord($sql))
				{
					if(in_array($aOrder['order_status'], array('payment_recieved', 'canceled', 'completed')))
					{
						// Status is final, don't update!
					}
					else
					{
						uc_order_comment_save($oOrder->order_id, 0, t('Recieved order status ' . $aRecord['transaction_status'] . ' from Payment Service Provider.'), 'admin');

						$sql = "UPDATE `uc_orders` SET `order_status` = 'pending' WHERE (`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "') LIMIT 1";
						idealcheckout_database_query($sql);


						// Clear cart
						if(!empty($aOrderParams['cart']['id']))
						{
							// Clear shopping cart
							// uc_cart_empty($aOrderParams['cart']['id']);
						}
					}


					$page = variable_get('uc_cart_checkout_complete_page', '');

					if(!empty($page))
					{
						drupal_goto($page);
					}

					return $output;
				}
			}
		}


		drupal_goto($base_url . '/cart');
	}

?>